<?xml version="1.0" encoding="UTF-8"?>
<sch:pattern abstract="true" id="AllowableUSGOVAgencyValues" xmlns:sch="http://purl.oclc.org/dsdl/schematron">  
  <sch:p id="codeDesc">
    This abstract pattern checks to see if a value exists in the US Government Agency Acronym List.
    The following parameters are used by this pattern:
    
    $context     := the context in which the searchValue exists.
    $searchTerm  := the value which you want to verify is in the list.
    $errMsg      := the error message text to display when the assertion fails.
  </sch:p>
  <sch:rule context="$context">
    <sch:let name="USGOVAgencyAcronymList"
      value="document('../../CVE/USGOVAgency/CVEnumUSGOVAgencyAcronym.xml')//cve:CVE/cve:Enumeration/cve:Term/cve:Value"/>
    <sch:assert
      test="some $token in $USGOVAgencyAcronymList satisfies
      $token = $searchTerm or 
      matches($searchTerm, concat('^',$token,'$'))"
      flag="error">
      <sch:value-of select="$errMsg"/>
    </sch:assert>
  </sch:rule>
</sch:pattern>